/usr/lib/interchange/Vend/Error.pm is in interchange 5.7.7-2.
This file is owned by root:root, with mode 0o644.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 | # Vend::Error - Handle Interchange error pages and messages
#
# $Id: Error.pm,v 2.15 2007-08-09 13:40:53 pajamian Exp $
#
# Copyright (C) 2002-2007 Interchange Development Group
# Copyright (C) 1996-2002 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301 USA.
package Vend::Error;
use Vend::Util;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw (
do_lockout
full_dump
get_locale_message
interaction_error
minidump
);
use strict;
use vars qw/$VERSION/;
$VERSION = substr(q$Revision: 2.15 $, 10);
sub get_locale_message {
my ($code, $message, @arg) = @_;
if ($Vend::Cfg->{Locale} and defined $Vend::Cfg->{Locale}{$code}) {
$message = $Vend::Cfg->{Locale}{$code};
}
elsif ($Global::Locale and defined $Global::Locale->{$code}) {
$message = $Global::Locale->{$code};
}
elsif ($Vend::Cfg->{Locale} and -f "$Global::ConfDir/$code.html" ) {
$message = readfile("$Global::ConfDir/$code.$::Scratch->{mv_locale}");
}
elsif (-f "$Global::ConfDir/$code.html") {
$message = readfile("$Global::ConfDir/$code.html");
}
if($message !~ /\s/) {
if($message =~ /^http:/) {
$message = header_data_scrub($message);
$Vend::StatusLine =~ s/([^\r\n])$/$1\r\n/;
$Vend::StatusLine .= "Status: 302 Moved\r\nLocation: $message\r\n";
$message = "Redirected to $message.";
}
else {
my $tmp = readin($message);
$message = $tmp if $tmp;
}
}
return sprintf($message, @arg);
}
## INTERFACE ERROR
# An incorrect response was returned from the browser, either because of a
# browser bug or bad html pages.
sub interaction_error {
my($msg) = @_;
my($page);
logError( "Difficulty interacting with browser: %s", $msg );
# avoid XSS problem
if ($msg !~ /^[\w\s\.]+$/) {
$msg = 'Invalid CGI input.';
}
$page = readin(find_special_page('interact'));
if (defined $page) {
$page =~ s#\[message\]#$msg#ig;
::interpolate_html($page, 1);
::response();
}
else {
logError( "Missing special page: interact" , '');
::response("$msg\n");
}
}
sub minidump {
my $out = <<EOF;
Full client host name: $CGI::remote_host
Full client IP address: $CGI::remote_addr
Query string was: $CGI::query_string
EOF
for(qw/browser last_url/) {
$out .= "$_: $Vend::Session->{$_}\n";
}
for(keys %{$Vend::Session->{carts}} ) {
next if ! $Vend::Session->{carts}->{$_};
$out .= scalar @{$Vend::Session->{carts}->{$_}};
$out .= " items in $_ cart.\n";
}
return $out;
}
sub full_dump {
my $portion = shift;
my $opt = shift || {};
my $out = '';
if($portion) {
$out .= "###### SESSION ($portion) #####\n";
$out .= uneval($Vend::Session->{$portion});
$out .= "\n###### END SESSION #####\n";
$out =~ s/\0/\\0/g;
return $out;
}
$out = minidump();
local($Data::Dumper::Indent) = 2;
unless ($opt->{no_env}) {
$out .= "###### ENVIRONMENT #####\n";
if(my $h = ::http()) {
$out .= uneval($h->{env});
}
else {
$out .= uneval(\%ENV);
}
$out .= "\n###### END ENVIRONMENT #####\n";
}
unless($opt->{no_cgi}) {
my %cgi = %CGI::values;
unless($opt->{show_all}) {
for(@Global::HideCGI) {
delete $cgi{$_};
}
}
$out .= "###### CGI VALUES #####\n";
$out .= uneval(\%cgi);
$out .= "\n###### END CGI VALUES #####\n";
}
unless($opt->{no_session}) {
$out .= "###### SESSION #####\n";
$out .= uneval($Vend::Session);
$out .= "\n###### END SESSION #####\n";
}
$out =~ s/\0/\\0/g;
return $out;
}
sub do_lockout {
my ($cmd);
my $msg = '';
# If the lockout SpecialSub exists, it is run. If it returns
# true, we return now. If it returns false, we run the lockout
# as normal.
if (my $subname = $Vend::Cfg->{SpecialSub}{lockout}) {
::logDebug(errmsg("running subroutine '%s' for lockout", $subname));
my $sub = $Vend::Cfg->{Sub}{$subname} || $Global::GlobalSub->{$subname};
my $status;
eval {
$status = $sub->();
};
if($@) {
::logError("Error running lockout subroutine %s: %s", $subname, $@);
}
return $status if $status;
}
# Now we log the error after custom lockout routine gets chance
# to bypass
my $pause = $::Limit->{lockout_reset_seconds} || 30;
$msg = errmsg(
"WARNING: POSSIBLE BAD ROBOT. %s accesses with no %d second pause.",
$Vend::Session->{accesses},
$pause,
);
::logError($msg);
if($cmd = $Global::LockoutCommand) {
my $host = $CGI::remote_addr;
$cmd =~ s/%s/$host/ or $cmd .= " $host";
$msg .= errmsg("Performing lockout command '%s'", $cmd);
system $cmd;
$msg .= errmsg("\nBad status %s from '%s': %s\n", $?, $cmd, $!)
if $?;
logGlobal({level => 'notice'}, $msg);
}
$Vend::Cfg->{VendURL} = $Vend::Cfg->{SecureURL} = 'http://127.0.0.1';
$Vend::LockedOut = 1;
logError($msg) if $msg;
return;
}
1;
|